<?php

class DemoConfig
{

    const PLUGIN_VERSION 	   = '5.9.1';

    const TV_FAVORITES_SUPPORTED   = true;

    const EPG_URL_FORMAT	= 'http://tv.lan.ua/epg/schedule_channel_%d_day_%s_nsc_1.html';

    const ALL_CHANNEL_GROUP_CAPTION     = 'Все каналы';
    const ALL_CHANNEL_GROUP_ICON_PATH   = 'http://dune.lan.ua/icons/all.png';
    const FAV_CHANNEL_GROUP_CAPTION     = 'Избранное';
    const FAV_CHANNEL_GROUP_ICON_PATH   = 'http://dune.lan.ua/icons/favorites.png';

    const GROUP_ICON_PATH   = 'http://dune.lan.ua/icons/g%d.png';
    
    const USE_M3U_FILE = true;

    const M3U_ICON_FILE_URL_FORMAT = 'http://dune.lan.ua/logo/%d.png';

    const M3U_ICON_FILE_URL_DEFAULT = 'http://dune.lan.ua/logo/online.png';

    const M3U_ID_FILE_URL = 'plugin_file://chanel/localnet_channels_id';

    const DATA_PATH = 'plugin_file://chanel/%s';

    const CHANNEL_SORT_FUNC_CB = 'DemoConfig::sort_channels_cb';

    public static function get_group_name($gid) {

    	$group_names = array('Общие', 'Познавательные', 'Новости', 'Развлекательные', 'Детские', 'Музыкальные', 'Комедийные', 
		'Спортивные', 'Интернациональные', 'Фильмы/Сериалы', 'Эротические', 'Бонусные', 'HD');
	$gid = array_key_exists($gid, $group_names) ? $gid : 0;    

	return array($gid, $group_names[$gid]);
    }

    ///////////////////////////////////////////////////////////////////////

    public static function sort_channels_cb($a, $b)
    {
        // Sort by channel numbers.
        //return strnatcasecmp($a->get_number(), $b->get_number());

        // Other options:
        return strnatcasecmp($a->get_title(), $b->get_title());
    }

    ///////////////////////////////////////////////////////////////////////
    // Folder views.

    public static function GET_TV_GROUP_LIST_FOLDER_VIEWS()
    {
        return array(
            array
            (
                PluginRegularFolderView::async_icon_loading => false,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 2,
                    ViewParams::num_rows => 10,
                    ViewParams::paint_details => false,
                    ViewParams::zoom_detailed_icon => false,
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
    		    ViewItemParams::item_paint_icon => true,
    		    ViewItemParams::item_layout => HALIGN_LEFT,
    		    ViewItemParams::icon_valign => VALIGN_CENTER,
    		    ViewItemParams::icon_dx => 10,
    		    ViewItemParams::icon_dy => -5,
    		    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
    		    ViewItemParams::item_caption_width => 700,

                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),

        );
    }

    public static function GET_TV_CHANNEL_LIST_FOLDER_VIEWS()
    {
        return array(
            array
            (
                PluginRegularFolderView::async_icon_loading => false,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 2,
                    ViewParams::num_rows => 10,
                    ViewParams::paint_details => false,
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
    		    ViewItemParams::item_paint_icon => true,
    		    ViewItemParams::item_layout => HALIGN_LEFT,
    		    ViewItemParams::icon_valign => VALIGN_CENTER,
    		    ViewItemParams::icon_dx => 10,
    		    ViewItemParams::icon_dy => -5,
    		    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
    		    ViewItemParams::item_caption_width => 700,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array 
		(
		    ViewItemParams::icon_path => 'http://dune.lan.ua/icons/0.png'
		),
            ),

        );
    }
    
}

?>
