﻿<?php
///////////////////////////////////////////////////////////////////////////
require_once 'lib/abstract_preloaded_regular_screen.php';
require_once 'lib/abstract_controls_screen.php';

///////////////////////////////////////////////////////////////////////////

class DemoSetupScreen extends AbstractControlsScreen
{
    const ID = 'setup';
	

    ///////////////////////////////////////////////////////////////////////

    public function __construct()
    {
        parent::__construct(self::ID);

	try {
		//$this->version_msg = HD::http_get_document(DemoConfig::CHECK_VERSION_URL);
	}
	catch (Exception $e) {
		$this->version_msg = 'unknown';	
	}
    }
	public static function get_media_url_str()
    {
        return MediaURL::encode(array('screen_id' => self::ID));
    }
	
    public function do_get_control_defs(&$plugin_cookies)
    {
        $defs = array();
        $show_tv = isset($plugin_cookies->show_tv) ?
        $plugin_cookies->show_tv : 'yes';
        $m3u = isset($plugin_cookies->m3u) ?
        $plugin_cookies->m3u : '';
        $use_proxy = isset($plugin_cookies->use_proxy) ?
        $plugin_cookies->use_proxy : 'no';
        $proxy_ip = isset($plugin_cookies->proxy_ip) ?
        $plugin_cookies->proxy_ip : '192.168.1.1';
		$proxy_port = isset($plugin_cookies->proxy_port) ?
		$plugin_cookies->proxy_port : '9999';
		$m3u_type = isset($plugin_cookies->m3u_type) ?
		$plugin_cookies->m3u_type : '1';
		$proxy_type = isset($plugin_cookies->proxy_type) ?
		$plugin_cookies->proxy_type : '1';
		$m3u_dir = isset($plugin_cookies->m3u_dir) ?
		$plugin_cookies->m3u_dir : '/D';
		$epg_shift = isset($plugin_cookies->epg_shift) ?
		$plugin_cookies->epg_shift : '0';
		$buf_time = isset($plugin_cookies->buf_time) ? 
		$plugin_cookies->buf_time : 0;
		$smb_user = isset($plugin_cookies->smb_user) ? 
		$plugin_cookies->smb_user : '';
		$smb_pass = isset($plugin_cookies->smb_pass) ? 
		$plugin_cookies->smb_pass : '';
		$ip_path = isset($plugin_cookies->ip_path) ? 
		$plugin_cookies->ip_path : '';
		$utils_tv = isset($plugin_cookies->utils_tv) ?
        $plugin_cookies->utils_tv : 'yes';
		$rec_shift = isset($plugin_cookies->rec_shift) ?
		$plugin_cookies->rec_shift : '0';
		

        $show_ops = array();
        $show_ops['yes'] = 'Да';
        $show_ops['no'] = 'Нет';
		
		$utils_ops = array();
        $utils_ops['yes'] = 'Да';
        $utils_ops['no'] = 'Нет';
		
		$show_buf_time_ops = array();

        $show_buf_time_ops[0] = 'По умолчанию       ';
        $show_buf_time_ops[500] = '0.5 сек.';
        $show_buf_time_ops[1000] = '1 сек.';
        $show_buf_time_ops[2000] = '2 сек.';
        $show_buf_time_ops[3000] = '3 сек.';
        $show_buf_time_ops[5000] = '5 сек.';
        $show_buf_time_ops[10000] = '10 сек.';
		
		$m3u_ops = array();
        $m3u_ops['1'] = 'Плейлисты из плагина';
        $m3u_ops['2'] = 'Плейлисты из каталога первого HDD/USB-диска';
        $m3u_ops['3'] = 'Плейлист по ссылке (http)';
		$m3u_ops['7'] = 'Плейлисты из SMB папки';
		$m3u_ops['6'] = 'Плейлисты по ссылке (http) из файла pls.txt';
		if (file_exists('/persistfs/main_screen_items/'))
			{
		$m3u_ops['4'] = 'Плейлисты из каталога Избранного';
			}
		if (file_exists('/flashdata/main_screen_items/'))
			{
		if (!file_exists('/persistfs/main_screen_items/'))
			{
		$m3u_ops['5'] = 'Плейлисты из каталога Избранного';
			}
			}
		
		$proxy_ops = array();
        $proxy_ops['1'] = 'Не сохранять адреса proxy';
        $proxy_ops['2'] = 'Cохранять адреса proxy';
       

	for ($i = -12; $i<13; $i++)
		$shift_ops[$i*3600] = $i; 
	for ($i = -12; $i<13; $i++)
		$rec_shift_ops[$i*3600] = $i; 

	$ver = file_get_contents(dirname(__FILE__).'/VERSION');
	$ver = str_replace("﻿version=", "", $ver);
	$ver = str_replace('date=', "[", $ver);
	$ver = str_replace(" 00:00", "]", $ver);
	$plugin_version = str_replace("\n", " ", $ver);
	
	$this->add_button
        (
            $defs,
            'info_release',
            "Версия: $plugin_version",
            'Информация об изменениях',
            0
        );


	$this->add_combobox($defs,
            'epg_shift', 'Коррекция ТВ программы(час.):',
            $epg_shift, $shift_ops, 0, true);
	
	$this->add_combobox
            ($defs,'buf_time', 'Время буферизации:', 
			$buf_time, $show_buf_time_ops, 0, true );
				
	if ($m3u_type == 2) {

	    $m3u_dir_ops = array();
	    $m3u_dir_ops['/D'] = '/';

	    foreach (glob('/D/*') as $file) 
    		if (is_dir($file)) $m3u_dir_ops[$file] = substr($file,3,strlen($file));


	    $this->add_combobox($defs,
            	'm3u_dir', 'Каталог:',
            	$m3u_dir, $m3u_dir_ops, 0, true);
	}
	else if ($m3u_type == 4) {

	    $m3u_dir_ops = array();
	    $m3u_dir_ops['/persistfs/main_screen_items/'] = '/';

	    foreach (glob('/persistfs/main_screen_items/*') as $file) 
    		if (is_dir($file)) $m3u_dir_ops[$file] = substr($file,29,strlen($file));


	    $this->add_combobox($defs,
            	'm3u_dir', 'Каталог в "Избранном":',
            	$m3u_dir, $m3u_dir_ops, 0, true);
	}
	else if ($m3u_type == 5) {

	    $m3u_dir_ops = array();
	    $m3u_dir_ops['/flashdata/main_screen_items/'] = '/';

	    foreach (glob('/flashdata/main_screen_items/*') as $file) 
    		if (is_dir($file)) $m3u_dir_ops[$file] = substr($file,29,strlen($file));


	    $this->add_combobox($defs,
            	'm3u_dir', 'Каталог в "Избранном":',
            	$m3u_dir, $m3u_dir_ops, 0, true);
	}
	else if ($m3u_type == 3) {
	    $this->add_text_field($defs,
        	'm3u', 'Ссылка на плейлист:', $m3u,
		false, false, false, true, 500, false, true);
	}
	else if ($m3u_type == 7) {
	    $this->add_text_field($defs,
                    'ip_path',
                   'Путь к SMB папке(IP/имя папки/..)',
                    $ip_path, 0, 0, 0, 1, 500, 0, true
            );
                $this->add_text_field($defs,
                    'smb_user',
                    'Имя пользователя SMB папки:',
                    $smb_user, 0, 0, 0, 1, 500, 0, true
            );

		$this->add_text_field($defs,
                    'smb_pass',
                    'Пароль SMB папки:',
                    $smb_pass, 0, 1, 0, 1, 500, 0, true
            );
		
	}
	if ($m3u_type == 6) {

	    $m3u_dir_ops = array();
	    $m3u_dir_ops['/D'] = '/';

	    foreach (glob('/D/*') as $file) 
    		if (is_dir($file)) $m3u_dir_ops[$file] = substr($file,3,strlen($file));


	    $this->add_combobox($defs,
            	'm3u_dir', 'Каталог c файлом  pls.txt:',
            	$m3u_dir, $m3u_dir_ops, 0, true);
	}

	
	if ($use_proxy == 'yes') {

    	    $this->add_text_field($defs,
        	'proxy_ip', 'Адрес proxy-сервера (IP или DNS):', $proxy_ip,
		false, false, false, true, 500, false, true);

	    $this->add_text_field($defs,
    		'proxy_port', 'Порт proxy-сервера:', $proxy_port,
        	true, false, false,  true, null, false, true);
	}
		
        return $defs;
    }
	
	public function do_get_pin_control_defs(&$plugin_cookies)
    {
        $defs = array();

        $pin1 = '';
        $pin2 = '';
        
        $this->add_text_field($defs,
            'pin1', 'Старый код закрытых каналов:',
            $pin1, 1, 1, 0, 1, 500, 0, false);
        $this->add_text_field($defs,
            'pin2', 'Новый код закрытых каналов:',
            $pin2, 1, 1, 0, 1, 500, 0, false);

        $this->add_label($defs, '', '');
        
        $this->add_close_dialog_and_apply_button($defs,
            'pin_apply', 'ОК', 250);
        $this->add_close_dialog_button($defs,
            'Отмена', 250);
 
        return $defs;
    }
	
    public function get_control_defs(MediaURL $media_url, &$plugin_cookies)
    {
        return $this->do_get_control_defs($plugin_cookies);
    }

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
        
		//hd_print('Setup: handle_user_input:');
        foreach ($user_input as $key => $value)
            //hd_print("  $key => $value");

        if ($user_input->action_type === 'confirm' || $user_input->action_type === 'apply' )
        {
            $control_id = $user_input->control_id;
            $new_value = $user_input->{$control_id};
            //hd_print("Setup: changing $control_id value to $new_value");

            if ($control_id === 'show_tv')
                $plugin_cookies->show_tv = $new_value;
			else if ($control_id === 'buf_time')
                $plugin_cookies->buf_time = $new_value;
			else if ($control_id === 'utils_tv')
                $plugin_cookies->utils_tv = $new_value;
            else if ($control_id === 'm3u')
                $plugin_cookies->m3u = $new_value;
			else if ($control_id === 'restart')
			{
                $url = 'plugin_launcher://localnet';
				return ActionFactory::launch_media_url($url);
			}
			else if ($control_id === 'info_release')
			{
                $doc = HD::http_get_document('http://dune.lan.ua/svn/info.txt');
				$tmp = explode('>>>', $doc);
				$text = $tmp[0];
				$defs = array();
				$texts = explode("\n", $text);
				$texts = array_values($texts);
				foreach($texts as $text)
				{
				ControlFactory::add_label($defs, "", trim($text));
				}
				ControlFactory::add_vgap($defs, -10);
				ControlFactory::add_close_dialog_button($defs,
                'ОК', 300);

				return ActionFactory::show_dialog('Информация об изменениях.', $defs);
			}
            else if ($control_id === 'm3u_type')
                $plugin_cookies->m3u_type = $new_value;
				
			else if ($control_id === 'proxy_type')
                $plugin_cookies->proxy_type = $new_value;
	   
			else if ($control_id === 'm3u_dir')
				$plugin_cookies->m3u_dir = $new_value;
			else if ($control_id === 'smb_user')
				$plugin_cookies->smb_user = $new_value;
			else if ($control_id === 'smb_pass')
				$plugin_cookies->smb_pass = $new_value;
			else if ($control_id === 'ip_path')
				$plugin_cookies->ip_path = $new_value;	
			else if ($control_id === 'epg_shift')
				$plugin_cookies->epg_shift = $new_value;
			else if ($control_id === 'rec_shift')
				$plugin_cookies->rec_shift = $new_value;
					
			else if ($control_id === 'use_proxy') {
					$plugin_cookies->use_proxy = $new_value;
					$plugin_cookies->proxy_ip = isset($plugin_cookies->proxy_ip) ? $plugin_cookies->proxy_ip : '192.168.1.1';
		    $plugin_cookies->proxy_port = isset($plugin_cookies->proxy_port) ? $plugin_cookies->proxy_port : '9999';
                }
            else if ($control_id === 'proxy_ip')
                $plugin_cookies->proxy_ip = $new_value;
            else if ($control_id === 'proxy_port')
                $plugin_cookies->proxy_port = $new_value;
		
			else if ($control_id === 'pin_dialog')
				{
					$defs = $this->do_get_pin_control_defs($plugin_cookies);
					
					return  ActionFactory::show_dialog
							(
								"Родительский контроль",
								$defs,
								true
							);
				}
			else if ($control_id === 'pin_apply')
				{
					if ($user_input->pin1 == '' || $user_input->pin2 == '')
						return null;
					
					$msg = '';
					$action = null;

					$pin = isset($plugin_cookies->pin) ? $plugin_cookies->pin : '0000';

					if ($user_input->pin1 == $pin)
					{
					$plugin_cookies->pin = $user_input->{'pin2'};
					$msg = 'Код изменен!';
					}
					else
					{
					$msg = 'Код не изменен!';
					}
				
					return  ActionFactory::show_title_dialog
							(
								$msg,
								$action
							);
				}
        }

        return ActionFactory::reset_controls(
            $this->do_get_control_defs($plugin_cookies));
    }
	
}

///////////////////////////////////////////////////////////////////////////
?>
